using System;
using FluorineFx;
using System.Collections.Generic;
using SACI.Comum.DataSet;
namespace IntegracaoFlex
{
    /// <summary>
    /// Representa uma Pessoa.
    /// </summary>
    [RemotingService]
    public class Empresa
    {
        private SACI.AcessoDados.cEmpresa oAcessoDados = new SACI.AcessoDados.cEmpresa();

        public void Listar(dsEmpresa ds, int id)
        {
            oAcessoDados.Listar(ds, id);
        }

        public void Listar(dsEmpresa ds, string clausulaWhere)
        {
            oAcessoDados.Listar (ds, clausulaWhere);
        }

        public dsEmpresa.EmpresaDataTable Lista(dsEmpresa ds, string clausulaWhere)
        {
            oAcessoDados.Listar(ds, clausulaWhere);
            return ds.Empresa;
        }

        public int Salvar(dsEmpresa.EmpresaRow empresa)
        {
            return oAcessoDados.Salvar(empresa);
        }
    
    }
}
