using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cLink : cBaseNegocio
    {
        private SACI.AcessoDados.cLink oAcessoDados = new SACI.AcessoDados.cLink();
        private dsLink ds = new dsLink();

        public String RetornaTeste()
        {
            oAcessoDados.Listar(ds,0);
            return ds.GetXml();

            //return "Estive no C# (cLink) e lembrei de vc!";
        }

        public String Listar(int id)
        {
            oAcessoDados.Listar(ds, id);
            return ds.GetXml();
        }
/*
        public String Listar(dsLink ds, string clausulaWhere)
        {
            oAcessoDados.Listar (ds, clausulaWhere);
            return ds.GetXml();
        }
*/
        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.Link);
        }


        public String Salvar(String dados)
        {
            String retorno = "";

            try
            {
                dsLink.LinkRow LinkRow;
                LinkRow = RetornarDataRow(ds, dados) as dsLink.LinkRow ;

                oAcessoDados.Salvar(LinkRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }
            
            return retorno;
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsLink.LinkRow LinkRow;
                LinkRow = RetornarDataRow(ds, dados) as dsLink.LinkRow;

                oAcessoDados.Excluir(LinkRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

    
    }
}
