  IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarFilial')
	BEGIN
		DROP  Procedure  p_ListarFilial
	END

GO

CREATE Procedure dbo.p_ListarFilial
	(
		@ID_Filial int = NULL 
		,@ID_Empresa int = NULL 
		,@ClausulaWhere varchar(50) = NULL
	)
AS

DECLARE @Where varchar(1000)

-- Adiciona Pesquisa do ID
IF(@ID_Filial IS NOT NULL)
	BEGIN
		SET @Where = ' ID_Filial=' + CONVERT(VARCHAR,@ID_Filial)
	END
ELSE IF (@ID_Empresa IS NOT NULL)
	BEGIN
		SET @Where = ' F.ID_Empresa=' + CONVERT(VARCHAR,@ID_Empresa)
	END
ELSE
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ' 
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

DECLARE @sSql varchar(7000)
SET @sSql = 'SELECT ID_Filial, Filial, RazaoSocial, F.ID_Empresa FROM Filial F LEFT JOIN Empresa E ON E.ID_Empresa = F.ID_Empresa '
		
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql)