    IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarICAtributoEstado')
	BEGIN
		DROP  Procedure  p_ListarICAtributoEstado
	END

GO

CREATE Procedure dbo.p_ListarICAtributoEstado
	(
		@ID_IC int = 0
		, @ID_ICAtributoEstado int = 0		
	)
AS

DECLARE @Where varchar(1000)

-- A pesquisa est ordem correta para funcionar(se necessitar altera, prestar ateno! veja os comentrios) 

-- Caso seja passado um ID_ICAtributoEstado especfico retorna s o registro solicitado (ignora os demais parmetros)
IF(@ID_ICAtributoEstado <> 0)
	BEGIN
		SET @Where = ' AE.ID_ICAtributoEstado=' + CONVERT(VARCHAR,@ID_ICAtributoEstado) 
	END
-- Caso seja passado o ID_IC, retorna os Atributos e Estados desse IC
ELSE IF(@ID_IC <> 0)
	BEGIN
		SET @Where = ' IA.ID_IC=' + CONVERT(VARCHAR,@ID_IC)
	END

	DECLARE @sSql varchar(7000)

	SET @sSql = '
SELECT 
	ISNULL(IA.ID_ICAtributo,0) as ID_ICAtributo, 
	ISNULL(IA.ID_IC,0) as ID_IC, 
	IA.ID_TipoICAtributo as ID_TipoICAtributo, 
	ISNULL(IA.Valor,'''') as Valor, 
	TA.Descricao as Descricao, 
	ISNULL(TA.TipoCampo,0) as TipoCampo, 
	ISNULL(TA.PermiteNull,1) as PermiteNull, 
	ISNULL(TA.TamanhoMaximo,0) as TamanhoMaximo,
	ISNULL(AE.ID_ICAtributoEstado,0) as ID_ICAtributoEstado, 
	AE.ID_TipoICAtributoEstado as ID_TipoICAtributoEstado, 
	ISNULL(AE.Valor,'''') as Valor_Estado, 
	TE.Descricao as Descricao_Estado, 
	ISNULL(TE.TipoCampo,0) as TipoCampo_Estado, 
	ISNULL(TE.PermiteNull,1) as PermiteNull_Estado, 
	ISNULL(TE.TamanhoMaximo,0) as TamanhoMaximo_Estado 
FROM 
	ICAtributo IA
	FULL JOIN TipoICAtributo TA ON TA.ID_TipoICAtributo = IA.ID_TipoICAtributo
	FULL JOIN ICAtributoEstado AE ON AE.ID_ICAtributo = IA.ID_ICAtributo
	FULL JOIN TipoICAtributoEstado TE ON TE.ID_TipoICAtributoEstado = AE.ID_TipoICAtributoEstado
'

	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql) 