   IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarICAtributoHistorico')
	BEGIN
		DROP  Procedure  p_ListarICAtributoHistorico
	END

GO

CREATE Procedure dbo.p_ListarICAtributoHistorico
	(
		@ID_ICAtributo int = 0		
	)
AS

DECLARE @Where varchar(1000)

IF(@ID_ICAtributo <> 0)
	BEGIN
		SET @Where = ' I.ID_ICAtributo=' + CONVERT(VARCHAR,@ID_ICAtributo) 
	END

	DECLARE @sSql varchar(7000)
	SET @sSql = 'SELECT I.ID_ICAtributo as ID_ICAtributo, ISNULL(Login,''-'') as Login, DataHora , TipoRegistro, ISNULL(TI.Descricao,I.Valor) as Valor'
	SET @sSql = @sSql + ' FROM ICAtributoHistorico I '
	SET @sSql = @sSql + ' LEFT JOIN Usuario U ON U.ID_Usuario = I.ID_Usuario'
	SET @sSql = @sSql + ' LEFT JOIN ICAtributo IA ON IA.ID_ICAtributo = I.ID_ICAtributo'
	SET @sSql = @sSql + ' LEFT JOIN TipoICAtributoItem TI ON (TI.ID_TipoICAtributo = IA.ID_TipoICAtributo AND CONVERT(VARCHAR,TI.Codigo) = I.Valor)'

	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

SET @sSQL = @sSQL + ' ORDER BY DataHora DESC'

execute(@sSql) 