    IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarICAtributo_2')
	BEGIN
		DROP  Procedure  p_ListarICAtributo_2
	END

GO

CREATE Procedure dbo.p_ListarICAtributo_2
	(
		@ID_ICAtributo int = NULL 
		,@ID_TipoICAtributo int = NULL
		,@ID_IC int = NULL
		,@ClausulaWhere varchar(250) = NULL
	)
AS

DECLARE @Where varchar(1000)

-- Adiciona Pesquisa do ID
IF(@ID_ICAtributo IS NOT NULL)
	BEGIN
		SET @Where = ' I.ID_ICAtributo=' + CONVERT(VARCHAR,@ID_ICAtributo)
	END
ELSE IF(@ID_TipoICAtributo IS NOT NULL AND @ID_IC IS NOT NULL)
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' I.ID_TipoICAtributo=' + CONVERT(VARCHAR,@ID_TipoICAtributo) + ' AND I.ID_IC=' + CONVERT(VARCHAR,@ID_IC)
	END	
ELSE IF(@ID_TipoICAtributo IS NOT NULL)
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' T.ID_TipoICAtributo=' + CONVERT(VARCHAR,@ID_TipoICAtributo)
	END	
ELSE IF(@ID_IC IS NOT NULL)
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' I.ID_IC=' + CONVERT(VARCHAR,@ID_IC)
	END
ELSE
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ' 
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

	DECLARE @sSql varchar(7000)
	SET @sSql = 'SELECT I.ID_ICAtributo, I.Valor, I.ID_TipoICAtributo, I.ID_IC, T.Descricao FROM ICAtributo I '
	SET @sSql = @sSql + ' LEFT JOIN TipoICAtributo T ON T.ID_TipoICAtributo = I.ID_TipoICAtributo'
	
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql) 