  IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarTipoIC')
	BEGIN
		DROP  Procedure  p_ListarTipoIC
	END

GO

CREATE Procedure dbo.p_ListarTipoIC
	(
		@ID int = NULL 
		,@ClausulaWhere varchar(50) = NULL
	)
AS

DECLARE @Where varchar(1000)

-- Adiciona Pesquisa do ID
IF(@ID IS NOT NULL)
	BEGIN
		SET @Where = ' ID_TipoIC=' + CONVERT(VARCHAR,@ID)
	END
ELSE
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ' 
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

DECLARE @sSql varchar(7000)
SET @sSql = 'SELECT ID_TipoIC, Descricao, Observacoes, (SELECT Count(ID_TipoICAtributo) FROM TipoICAtributo TA WHERE TA.ID_TipoIC = T.ID_TipoIC) AS QuantidadeAtributos FROM TipoIC T'
		
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql) 