   IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarTipoICAtributo')
	BEGIN
		DROP  Procedure  p_ListarTipoICAtributo
	END

GO

CREATE Procedure dbo.p_ListarTipoICAtributo
	(
		@ID int = NULL 
		,@ID_TipoIC int = NULL 
		,@ClausulaWhere varchar(50) = NULL
	)
AS

DECLARE @Where varchar(1000)

-- Adiciona Pesquisa do ID
IF(@ID IS NOT NULL)
	BEGIN
		SET @Where = ' ID_TipoICAtributo=' + CONVERT(VARCHAR,@ID)
	END
ELSE IF(@ID_TipoIC IS NOT NULL)
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ID_TipoIC=' + CONVERT(VARCHAR,@ID_TipoIC)
	END
ELSE 
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ' 
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

DECLARE @sSql varchar(7000)
SET @sSql = 'SELECT ID_TipoICAtributo, Descricao, Unidade, ID_TipoIC, (SELECT Count(ID_TipoICAtributoEstado) FROM TipoICAtributoEstado TE WHERE TE.ID_TipoICAtributo = T.ID_TipoICAtributo) as QtdEstados FROM TipoICAtributo T'
		
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql) 