    IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarTipoICAtributoEstado')
	BEGIN
		DROP  Procedure  p_ListarTipoICAtributoEstado
	END

GO

CREATE Procedure dbo.p_ListarTipoICAtributoEstado
	(
		@ID int = NULL 
		,@ID_TipoICAtributo int = NULL 
		,@ClausulaWhere varchar(50) = NULL
	)
AS

DECLARE @Where varchar(1000)

-- Adiciona Pesquisa do ID
IF(@ID IS NOT NULL)
	BEGIN
		SET @Where = ' ID_TipoICAtributoEstado=' + CONVERT(VARCHAR,@ID)
	END
ELSE IF(@ID_TipoICAtributo IS NOT NULL)
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ID_TipoICAtributo=' + CONVERT(VARCHAR,@ID_TipoICAtributo)
	END
ELSE 
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ' 
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

DECLARE @sSql varchar(7000)
SET @sSql = 'SELECT ID_TipoICAtributoEstado, Descricao, ID_TipoICAtributo, Observacoes FROM TipoICAtributoEstado T'
		
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql) 