IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_SalvarIC')
	BEGIN
		DROP  Procedure  p_SalvarIC
	END

GO

CREATE Procedure dbo.p_SalvarIC
(
	@ID_IC int = 0
	, @Descricao varchar(50)
	, @IP varchar(15)
	, @Status int
	, @Monitorar bit
	, @ID_TipoIC int 
	, @ID_Departamento int 
	, @ID_ICPai int 
)
AS

	-- O ID_ICPai chega como 0 quando no existe um IC_Pai.... transformar em Null
	IF(@ID_ICPai =0)
		BEGIN
			SET @ID_ICPai = null
		END

	IF(@ID_IC=0) -- Incluso
		BEGIN
			INSERT INTO 
				IC
				(
					Descricao
					,IP
					,Status
					,Monitorar
					,ID_TipoIC
					,ID_Departamento
					,ID_ICPai
				)
			VALUES
				(
					@Descricao
					,@IP
					,@Status
					,@Monitorar
					,@ID_TipoIC
					,@ID_Departamento
					,@ID_ICPai
				)
		
		SELECT @@Identity AS Retorno
		
		END
	ELSE -- Alterao
		BEGIN
			UPDATE
				IC
			SET

				Descricao = @Descricao
				,IP = @IP
				,Status = @Status
				,Monitorar = @Monitorar
				,ID_TipoIC = @ID_TipoIC
				,ID_Departamento = @ID_Departamento
				,ID_ICPai = @ID_ICPai
			WHERE
				ID_IC = @ID_IC
				
			SELECT @ID_IC AS Retorno
		END
		
	  