   IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_SalvarTipoICAtributoEstado')
	BEGIN
		DROP  Procedure  p_SalvarTipoICAtributoEstado
	END

GO

CREATE Procedure dbo.p_SalvarTipoICAtributoEstado
(
	@ID int = 0
	, @Descricao varchar(50)
	, @Observacoes varchar(250)
	, @ID_TipoICAtributo int = 0
)
AS
	IF(@ID=0) -- Incluso
		BEGIN
			INSERT INTO 
				TipoICAtributoEstado
				(
					Descricao
					, Observacoes
					, ID_TipoICAtributo
				)
			VALUES
				(
					@Descricao 
					, @Observacoes 
					, @ID_TipoICAtributo
				)
		
		SELECT @@Identity AS Retorno
		
		END
	ELSE -- Alterao
		BEGIN
			UPDATE
				TipoICAtributoEstado
			SET
				Descricao = @Descricao
				, Observacoes = @Observacoes
				, ID_TipoICAtributo = @ID_TipoICAtributo
			WHERE
				ID_TipoICAtributoEstado=@ID
				
			SELECT @ID AS Retorno
		END
		
	 