-- Script para o INSERT dos atributos
IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 't_SalvarHistoricoICAtributoInsert')
	BEGIN
		DROP  Trigger t_SalvarHistoricoICAtributoInsert
	END
GO

CREATE Trigger t_SalvarHistoricoICAtributoInsert ON ICAtributo 
AFTER INSERT
AS 
	INSERT INTO ICAtributoHistorico
	SELECT ID_ICAtributo,1,getdate(),0,Valor FROM INSERTED

GO



-- Script para o UPDATE dos Atributos
IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 't_SalvarHistoricoICAtributo')
	BEGIN
		DROP  Trigger t_SalvarHistoricoICAtributo
	END
GO

CREATE Trigger t_SalvarHistoricoICAtributo ON ICAtributo 
AFTER UPDATE
AS 
	INSERT INTO ICAtributoHistorico
	SELECT ID_ICAtributo,1,getdate(),1,Valor FROM INSERTED

GO

