package util
{
    import mx.controls.Alert;
    import mx.messaging.ChannelSet;
    import mx.messaging.channels.AMFChannel;
    import mx.rpc.events.FaultEvent;
    import mx.rpc.events.ResultEvent;
    import mx.rpc.remoting.mxml.RemoteObject;
    
    public class OR extends RemoteObject
    {
    	
    	private var rstSucessoFunc:Function;
		private var _classe:String;
		private var _sucessFunction:Function;

        public function OR(classe:String, rstSucesso:Function = null)
        {
        	
        	var cs:ChannelSet = new ChannelSet();
        	cs.addChannel(new AMFChannel("my-amf","http://localhost:15271/Gateway.aspx"))
        	this.destination = "fluorine";
        	this.channelSet = cs;
            this.source = classe;
            this.showBusyCursor = true;
            //this.concurrency = "multiple";
            
            rstSucessoFunc = rstSucesso;
            
            this.addEventListener(FaultEvent.FAULT, rstFalha);
			            
            if (rstSucesso != null)
            	{
                this.addEventListener(ResultEvent.RESULT, rstSucesso);
                //this.addEventListener(ResultEvent.RESULT, rstFecha);
        		}
        }


        private function rstFalha(evt:FaultEvent):void{
            Alert.show("Ocorreu um erro ao tentar executar o método no asp.net.\r\r" + 
                evt.fault.message, "Erro");
        }

        public function fechaConexao():void
        {
            Alert.show("Fechando a conexão !");
            this.disconnect();
        }

        private function rstFecha(evt:ResultEvent):void
        {
            Alert.show("Fechando a conexão !");
            this.disconnect();
            this.removeEventListener(ResultEvent.RESULT, rstSucessoFunc);
            this.removeEventListener(FaultEvent.FAULT, rstFalha);
        }
		
		public function get classe():String
		{					
			return _classe;
		}
		
		public function set classe(value:String):void
		{
	 		this.source = classe;
	 		_classe = value;
		}


		public function get sucessFunction():Function
		{					
			return _sucessFunction;
		}
		
		public function set sucessFunction(value:Function):void
		{

            if (value != null)
            	{
                this.addEventListener(ResultEvent.RESULT, value);
        		}
	 		_sucessFunction = value;
		}

    }
}