using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cOID : cBaseAcessoDados
    {

        public void Listar(dsMonitoramento ds, int id)
        {
            selectCommand = new SqlCommand();
            //
            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_OID", id));

            //
            base.DoSelect(ds, "p_ListarOID", ds.OID.TableName);
        }

        public void Listar(dsMonitoramento ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarOID", ds.OID.TableName);
        }

        public int Salvar(dsMonitoramento.OIDRow oid)
        {

            dsMonitoramento.OIDRow oidAnterior = RetornaValorAnterior(oid.ID_OID);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", oid.ID_OID));
            //selectCommand.Parameters.Add(new SqlParameter("@CNPJ", oid.CNPJ));
            //selectCommand.Parameters.Add(new SqlParameter("@RazaoSocial", oid.RazaoSocial));
            //selectCommand.Parameters.Add(new SqlParameter("@Apelido", oid.Apelido));
            //selectCommand.Parameters.Add(new SqlParameter("@Endereco", oid.Endereco));
            //selectCommand.Parameters.Add(new SqlParameter("@Bairro", oid.Bairro));
            //selectCommand.Parameters.Add(new SqlParameter("@Cidade", oid.Cidade));
            //selectCommand.Parameters.Add(new SqlParameter("@UF", oid.UF));
            //selectCommand.Parameters.Add(new SqlParameter("@CEP", oid.CEP));
            //selectCommand.Parameters.Add(new SqlParameter("@complemento", oid.Complemento));
            //selectCommand.Parameters.Add(new SqlParameter("@Homepage", oid.HomePage));
            //selectCommand.Parameters.Add(new SqlParameter("@Email", oid.Email));
            //selectCommand.Parameters.Add(new SqlParameter("@Ativo", oid.Ativo));
            //

            dsMonitoramento ds = new dsMonitoramento();
            base.DoSelect(ds, "p_SalvarOID", "SalvarOID");

            base.GeraTrilhaAuditoria(oid.ID_OID, oidAnterior, oid);

            return int.Parse(ds.SalvarOID[0].Retorno.ToString());
        }

        private dsMonitoramento.OIDRow RetornaValorAnterior(int ID_OID)
        {

            dsMonitoramento ds = new dsMonitoramento();

            dsMonitoramento.OIDRow oidAnterior;

            if (ID_OID == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                //                dsMonitoramento.OIDRow oidAnterior = ds.OID.NewOIDRow();
                oidAnterior = ds.OID.NewOIDRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_OID);
                //                dsMonitoramento.OIDRow oidAnterior = ds.OID[0];
                oidAnterior = ds.OID[0];
            }

            return oidAnterior;

        }

        public void Excluir(dsMonitoramento.OIDRow oid)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", oid.ID_OID));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirOID", "ExcluirOID");

        }



    }
}

