using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Reflection;
using System.Xml;


namespace SACI.Negocio
{
    public abstract class cBaseNegocio
    {

        public string RetornarEstruturaDS(DataTable tabela)
        {

            String retorno;

            retorno = "<" + tabela.DataSet.DataSetName.ToString() + ">";
            retorno += "<" + tabela.TableName.ToString() + ">";

            foreach (DataColumn campo in tabela.Columns)
            {
                retorno += "<" + campo.ColumnName.ToString() + "/>";
            }

            retorno += "</" + tabela.TableName.ToString() + ">";
            retorno += "</" + tabela.DataSet.DataSetName.ToString() + ">";

            return retorno;
        }

        public DataRow RetornarDataRow(DataSet ds, String dados)
        {

            String table;
            String dataSet;

            // Retira o primeiro nodo (que contem o nome do dataSet
            table = dados.Substring(dados.IndexOf(">") + 2, dados.Length - dados.IndexOf(">") - 2);
            // Separa o valor do segundo nodo (que contem o nome da tabela)
            table = table.Substring(0, table.IndexOf(">"));
            
            // separa o nome do dataset
            dataSet = dados.Substring(1, dados.IndexOf(">") - 1);
            
            // insere o namespace no xml (seno o medoto ReadXml no carrega os dados da DataTable correta)
            dados = "<" + dataSet + " xmlns=\"http://tempuri.org/" + dataSet + ".xsd\"" + dados.Substring(dados.IndexOf(">"), dados.Length - dados.IndexOf(">"));

            // Cria um StringReader e carrega os dados
            System.IO.StringReader xmlSR = new System.IO.StringReader(dados);
            
            // Carrega o XML (no formato string) no dataSet
            ds.ReadXml(xmlSR, System.Data.XmlReadMode.IgnoreSchema);

            // Preenche um DataRow (que ser retornado pelo metodo) com os dados
            System.Data.DataRow linha;
            linha = ds.Tables[table].Rows[0];
            
            return linha;
        
        }

/*
        public string RetornarDadosParaCombo(DataSet ds, String campoData, String campoLabel)
        {
        }


        // Retorna (Form para XML)
        public string RetornarFormParaXML(string nomeTabela)
        {

            String retorno;
            retorno = "lolo";

            //Type tabela = System.Type(nomeTabela);

            //retorno = "<" + tabela.DataSet.DataSetName.ToString() + ">";
            //retorno += "<" + tabela.TableName.ToString() + ">";

            //foreach (DataColumn campo in tabela.Columns)
            //{
            //    retorno += "<" + campo.ColumnName.ToString() + "/>";
            //}

            //retorno += "</" + tabela.TableName.ToString() + ">";
            //retorno += "</" + tabela.DataSet.DataSetName.ToString() + ">";



            //retorno += "                    <BR><BR>lololololo<BR><BR>";
            //retorno += "dados.Empresa.ID_Empresa = txtCodigo.text;";
            //retorno += "dados.Empresa.CNPJ = txtCNPJ.text;";
            //retorno += "dados.Empresa.RazaoSocial = txtRazaoSocial.text;";
            //retorno += "dados.Empresa.Apelido = txtApelido.text;";
            //retorno += "dados.Empresa.Endereco = txtEndereco.text;";

            return retorno;
        }







        //--------------------------
        public string PopularDataRow(DataRow linha, String xml)
        {

            String retorno;
            retorno = "";

            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.LoadXml(xml);

            foreach (DataColumn campo in linha.Table.Columns)
            {

                

                //linha[campo.ColumnName.ToString()] = xmlDoc[campo.ColumnName.ToString()];
                        }
          

                                    //retorno = "<" + tabela.DataSet.DataSetName.ToString() + ">";
                                    //retorno += "<" + tabela.TableName.ToString() + ">";

                                    //foreach (DataColumn campo in tabela.Columns)
                                    //{
                                    //    retorno += "<" + campo.ColumnName.ToString() + "/>";
                                    //}

                                    //retorno += "</" + tabela.TableName.ToString() + ">";
                                    //retorno += "</" + tabela.DataSet.DataSetName.ToString() + ">";

            return retorno;
        }
*/

    }
}
