using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cDepartamento : cBaseNegocio
    {
        private SACI.AcessoDados.cDepartamento cAcessoDados = new SACI.AcessoDados.cDepartamento();
        private dsDepartamento ds = new dsDepartamento();
        private cFilial cFilial;

        public String Listar(int id, int tipoPesquisa)
        {
            cAcessoDados.Listar(ds, id, tipoPesquisa);
            return ds.GetXml();
        }

        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.Departamento);

        }

        //public void Listar(dsDepartamento ds, string clausulaWhere)
        //{
        //    oAcessoDados.Listar(ds, clausulaWhere);
        //}

        public String Salvar(String dados)
        {
            String retorno = "";

            //return dados;

            try
            {
                dsDepartamento.DepartamentoRow departamentoRow;
                departamentoRow = RetornarDataRow(ds, dados) as dsDepartamento.DepartamentoRow;

                cAcessoDados.Salvar(departamentoRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsDepartamento.DepartamentoRow departamentoRow;
                departamentoRow = RetornarDataRow(ds, dados) as dsDepartamento.DepartamentoRow;

                cAcessoDados.Excluir(departamentoRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }
    
    
    }
}
