using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cEmpresa : cBaseNegocio
    {
        private SACI.AcessoDados.cEmpresa cAcessoDados = new SACI.AcessoDados.cEmpresa();
        private dsEmpresa ds = new dsEmpresa();

        public String RetornaTeste()
        {
            cAcessoDados.Listar(ds,0);
            return ds.GetXml();

            //return "Estive no C# (cEmpresa) e lembrei de vc!";
        }

        public String Listar(int id)
        {
            cAcessoDados.Listar(ds, id);
            return ds.GetXml();
        }
/*
        public String Listar(dsEmpresa ds, string clausulaWhere)
        {
            oAcessoDados.Listar (ds, clausulaWhere);
            return ds.GetXml();
        }
*/
        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.Empresa);
        }


        public String Salvar(String dados)
        {
            String retorno = "";

            try
            {
                dsEmpresa.EmpresaRow empresaRow;
                empresaRow = RetornarDataRow(ds, dados) as dsEmpresa.EmpresaRow ;

                cAcessoDados.Salvar(empresaRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }
            
            return retorno;
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsEmpresa.EmpresaRow empresaRow;
                empresaRow = RetornarDataRow(ds, dados) as dsEmpresa.EmpresaRow;

                cAcessoDados.Excluir(empresaRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

    
    }
}
