using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cFornecedor : cBaseNegocio
    {
        private SACI.AcessoDados.cFornecedor cAcessoDados = new SACI.AcessoDados.cFornecedor();
        private dsFornecedor ds = new dsFornecedor();

        public String Listar(int id)
        {
            cAcessoDados.Listar(ds, id);
            return ds.GetXml();
        }
        /*
                public String Listar(dsFornecedor ds, string clausulaWhere)
                {
                    oAcessoDados.Listar (ds, clausulaWhere);
                    return ds.GetXml();
                }
        */
        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.Fornecedor);
        }


        public String Salvar(String dados)
        {
            String retorno = "";
            cIC lolo = new cIC();

            String xpto = lolo.RetornarModelo();

            try
            {
                dsFornecedor.FornecedorRow fornecedorRow;
                fornecedorRow = RetornarDataRow(ds, dados) as dsFornecedor.FornecedorRow;

                cAcessoDados.Salvar(fornecedorRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsFornecedor.FornecedorRow fornecedorRow;
                fornecedorRow = RetornarDataRow(ds, dados) as dsFornecedor.FornecedorRow;

                cAcessoDados.Excluir(fornecedorRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }


    }
}