using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]    
    public class cTipoIC : cBaseNegocio
    {
        private SACI.AcessoDados.cTipoIC cAcessoDados = new SACI.AcessoDados.cTipoIC();
        private dsTipoIC ds = new dsTipoIC();

        public String Listar(int id)
        {
            cAcessoDados.Listar(ds, id);
            return ds.GetXml();
        }

/*
        public String Listar(string clausulaWhere)
        {
            oAcessoDados.Listar(ds, clausulaWhere);
            return ds.GetXml();
        }
*/

        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.TipoIC);
        }

        public int Salvar(dsTipoIC.TipoICRow tipoIC)
        {
            return cAcessoDados.Salvar(tipoIC);
        }

        public void Excluir(dsTipoIC.TipoICRow tipoIC)
        {
            cAcessoDados.Excluir(tipoIC);
        }

    }
}
