using System;
using System.Collections.Generic;
using System.Text;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    public class cTipoICAtributoItem : cBaseNegocio
    {
        private SACI.AcessoDados.cTipoICAtributoItem cAcessoDados = new SACI.AcessoDados.cTipoICAtributoItem();
        private dsTipoIC ds = new dsTipoIC();
        private cTipoICAtributo cTipoICAtributo;

        public void Listar(dsTipoIC ds, int id_TipoICAtributoItem, int id_TipoIC)
        {
            cAcessoDados.Listar(ds, id_TipoICAtributoItem);
        }

        public void Listar(dsTipoIC ds, string clausulaWhere)
        {
            cAcessoDados.Listar(ds, clausulaWhere);
        }

        public int Salvar(dsTipoIC.TipoICAtributoItemRow tipoICAtributoItem)
        {
            return cAcessoDados.Salvar(tipoICAtributoItem);
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsTipoIC.TipoICAtributoItemRow tipoICAtributoItemRow;
                tipoICAtributoItemRow = RetornarDataRow(ds, dados) as dsTipoIC.TipoICAtributoItemRow;

                cAcessoDados.Excluir(tipoICAtributoItemRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String RetornarModelo()
        {
             return base.RetornarEstruturaDS(ds.TipoICAtributoItem);
        }

    }
}
