  IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarDepartamento')
	BEGIN
		DROP  Procedure  p_ListarDepartamento
	END

GO

CREATE Procedure dbo.p_ListarDepartamento
	(
		@ID_Departamento int = NULL 
		,@ID_Filial int = NULL 
		,@ClausulaWhere varchar(50) = NULL
	)
AS

DECLARE @Where varchar(1000)

-- Adiciona Pesquisa do ID
IF(@ID_Departamento IS NOT NULL)
	BEGIN
		SET @Where = ' ID_Departamento=' + CONVERT(VARCHAR,@ID_Departamento)
	END
ELSE IF (@ID_Filial IS NOT NULL)
	BEGIN
		SET @Where = ' F.ID_Filial=' + CONVERT(VARCHAR,@ID_Filial)
	END
ELSE
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ' 
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

DECLARE @sSql varchar(7000)
SET @sSql = 'SELECT ID_Departamento, Departamento, D.ID_Filial, F.Filial, F.ID_Empresa, E.RazaoSocial FROM Departamento D LEFT JOIN Filial F ON F.ID_Filial = D.ID_Filial LEFT JOIN Empresa E ON E.ID_Empresa = F.ID_Empresa '
		
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql) 