    IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarICAtributoHistoricoAlteracao')
	BEGIN
		DROP  Procedure  p_ListarICAtributoHistoricoAlteracao
	END

GO

CREATE Procedure dbo.p_ListarICAtributoHistoricoAlteracao
	(
		@ID_ICAtributo int = 0		
	)
AS

DECLARE @Where varchar(1000)

-- A pesquisa est ordem correta para funcionar(se necessitar altera, prestar ateno! veja os comentrios) 

-- Caso seja passado um ID_ICAtributo especfico retorna s o registro solicitado (ignora os demais parmetros)
IF(@ID_ICAtributo <> 0)
	BEGIN
		SET @Where = ' I.ID_ICAtributo=' + CONVERT(VARCHAR,@ID_ICAtributo) 
	END
-- Caso seja passado o ID_IC, retorna os Atributos desse IC e os atributos do Tipo dele (que no existem no ICAtributo
ELSE IF(@ID_IC <> 0)
	BEGIN
		SET @Where = ' I.ID_IC=' + CONVERT(VARCHAR,@ID_IC)
		SET @Where = @Where + ' OR I.ID_IC IS NULL AND T.ID_TipoIC IN '
		SET @Where = @Where + ' (SELECT ID_TipoIC FROM IC WHERE ID_IC=' + CONVERT(VARCHAR,@ID_IC) + ')'
	END
-- Caso seja passado um tipo de IC retorna somente os atributos no gravados na ICAtributo 
-- isto , RETORNA OS ATRIBUTOS EM BRANCO (para usar num IC novo)
ELSE IF(@ID_TipoIC <> 0)
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' I.ID_IC IS NULL AND T.ID_TipoIC=' + CONVERT(VARCHAR,@ID_TipoIC)
	END

	DECLARE @sSql varchar(7000)
	SET @sSql = 'SELECT ISNULL(I.ID_ICAtributo,0) as ID_ICAtributo, ISNULL(I.ID_IC,0) as ID_IC, T.ID_TipoICAtributo as ID_TipoICAtributo, ISNULL(I.Valor,'''') as Valor, T.Descricao as Descricao, '
	SET @sSql = @sSql + 'T.Grupo as Grupo, ISNULL(TipoCampo,0) as TipoCampo, ISNULL(PermiteNull,1) as PermiteNull, ISNULL(TamanhoMaximo,0) as TamanhoMaximo '
	SET @sSql = @sSql + ' FROM ICAtributo I '
	SET @sSql = @sSql + ' FULL JOIN TipoICAtributo T ON T.ID_TipoICAtributo = I.ID_TipoICAtributo'


	SET @sSql = @sSql + ' WHERE ID_ICAtributo=' + CONVERT(VARCHAR,@ID_ICAtributo)
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

SET @sSQL = @sSQL + ' ORDER BY T.Grupo'

execute(@sSql) 