IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_SalvarCampo')
	BEGIN
		DROP  Procedure  p_SalvarCampo
	END

GO

CREATE Procedure dbo.p_SalvarCampo
(
	@ID_Campo int = 0
	, @ID_Controle int = 0  
	, @Descricao varchar(100)
)
AS
	IF(@ID_Campo=0) -- Incluso
		BEGIN
			INSERT INTO 
				Campo
				(
					ID_Controle
					, Descricao
				)
			VALUES
				(
					@ID_Controle 
					, @Descricao 
				)
				
		SELECT @@Identity AS Retorno
						
		END
	ELSE -- Alterao
		BEGIN
			UPDATE
				Campo
			SET
				ID_Controle = @ID_Controle
				, Descricao = @Descricao
			WHERE
				ID_Campo=@ID_Campo
				
			SELECT @ID_Campo AS Retorno				

		END
		
	  