IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_SalvarConfiguracaoAlerta')
	BEGIN
		DROP  Procedure  p_SalvarConfiguracaoAlerta
	END

GO

CREATE Procedure dbo.p_SalvarConfiguracaoAlerta
(
	   @ID_ConfiguracaoAlerta int = 0
	   , @ID_ICAtributo int
	   , @Descricao varchar(100)
	   , @Quando int
	   , @Media int
	   , @Condicao int
	   , @Valor varchar(250)
	   , @IntervaloVerificacao int
	   , @EnviaEmail bit
	   , @EnviaMensagem bit
	   , @Ativo bit
)
AS
	IF(@ID_ConfiguracaoAlerta=0) -- Incluso
		BEGIN
			INSERT INTO 
				ConfiguracaoAlerta
				(
				   ID_ICAtributo
				   , Descricao
				   , Quando
				   , Media
				   , Condicao
				   , Valor
				   , IntervaloVerificacao
				   , EnviaEmail
				   , EnviaMensagem
				   , Ativo
				)
			VALUES
				(
				   @ID_ICAtributo
				   , @Descricao
				   , @Quando
				   , @Media
				   , @Condicao
				   , @Valor
				   , @IntervaloVerificacao
				   , @EnviaEmail
				   , @EnviaMensagem
				   , @Ativo
				)
		
		SELECT @@Identity AS Retorno
		
		END
	ELSE -- Alterao
		BEGIN
			UPDATE
				ConfiguracaoAlerta
			SET
			   ID_ICAtributo = @ID_ICAtributo
			   , Descricao = @Descricao
			   , Quando = @Quando
			   , Media = @Media
			   , Condicao = @Condicao
			   , Valor = @Valor
			   , IntervaloVerificacao = @IntervaloVerificacao
			   , EnviaEmail = @EnviaEmail
			   , EnviaMensagem = @EnviaMensagem
			   , Ativo = @Ativo
			WHERE
				ID_ConfiguracaoAlerta = @ID_ConfiguracaoAlerta
				
			SELECT @ID_ConfiguracaoAlerta AS Retorno
		END
		
	  