 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_SalvarConfiguracaoMonitoramento')
	BEGIN
		DROP  Procedure  p_SalvarConfiguracaoMonitoramento
	END

GO

CREATE Procedure dbo.p_SalvarConfiguracaoMonitoramento
(
	   @ID_ConfiguracaoMonitoramento int = 0
	   , @ID_ICAtributo int
	   , @ID_OID int
	   , @Descricao varchar(250)
	   , @SequenciaOID varchar(50)
	   , @TipoRetorno int
	   , @IntervaloVerificacao int
	   , @ColetorResponsavel varchar(100)
	   , @Ativo bit
)
AS
	IF(@ID_ConfiguracaoMonitoramento=0) -- Incluso
		BEGIN
			INSERT INTO 
				ConfiguracaoMonitoramento
				(
				   ID_ICAtributo
				   , ID_OID
				   , Descricao
				   , SequenciaOID
				   , TipoRetorno
				   , IntervaloVerificacao
				   , ColetorResponsavel
				   , DataProximaVerificacao
				   , Ativo
				)
			VALUES
				(
				   @ID_ICAtributo
				   , @ID_OID
				   , @Descricao
				   , @SequenciaOID
				   , @TipoRetorno
				   , @IntervaloVerificacao
				   , @ColetorResponsavel
				   , GetDate()
				   , @Ativo
				)
		
		SELECT @@Identity AS Retorno
		
		END
	ELSE -- Alterao
		BEGIN
			UPDATE
				ConfiguracaoMonitoramento
			SET
			   ID_ICAtributo = @ID_ICAtributo
			   , ID_OID = @ID_OID
			   , Descricao = @Descricao
			   , SequenciaOID = @SequenciaOID
			   , TipoRetorno = @TipoRetorno
			   , IntervaloVerificacao = @IntervaloVerificacao
			   , ColetorResponsavel = @ColetorResponsavel
			   , DataProximaVerificacao = GetDate()
			   , Ativo = @Ativo
			WHERE
				ID_ConfiguracaoMonitoramento = @ID_ConfiguracaoMonitoramento
				
			SELECT @ID_ConfiguracaoMonitoramento AS Retorno
		END
		
	  